{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          inherit system;
          config.allowUnfree = true;
        };

        shellWithPkgs = packages: pkgs.mkShell {
          inherit packages;
        };
      in
      {
        devShells.default = shellWithPkgs [ pkgs.codeql ];
      });
}


